Index: code-analyse.c
===================================================================
RCS file: /home/cvspublic/kaffe/kaffe/kaffevm/code-analyse.c,v
retrieving revision 1.5
diff -u -r1.5 code-analyse.c
--- code-analyse.c	1998/09/24 18:36:35	1.5
+++ code-analyse.c	1998/10/01 14:51:22
@@ -133,12 +133,16 @@
 			SET_STARTOFBASICBLOCK(tabpc);
 			SET_JUMPFLOW(pc, tabpc);
 			pc = pc + INSNLEN(pc);
+			if(pc < codeInfo->codelen)
+			    SET_STARTOFBASICBLOCK(pc);
 			break;
 		case GOTO_W:
 			tabpc = pc + DWORD(pc+1);
 			SET_STARTOFBASICBLOCK(tabpc);
 			SET_JUMPFLOW(pc, tabpc);
 			pc = pc + INSNLEN(pc);
+			if(pc < codeInfo->codelen)
+			    SET_STARTOFBASICBLOCK(pc);
 			break;
 		case JSR:
 			tabpc = pc + WORD(pc+1);
@@ -166,6 +170,8 @@
 			SET_STARTOFBASICBLOCK(pc+DWORD(tabpc));
 			SET_JUMPFLOW(pc, pc+DWORD(tabpc));
 			pc = tabpc + (DWORD(tabpc+8)-DWORD(tabpc+4)+1+3) * 4;
+			if(pc < codeInfo->codelen)
+			    SET_STARTOFBASICBLOCK(pc);
 			break;
 		case LOOKUPSWITCH:
 			tabpc = (pc + 4) & -4;
@@ -177,11 +183,15 @@
 			SET_STARTOFBASICBLOCK(pc+DWORD(tabpc));
 			SET_JUMPFLOW(pc, pc+DWORD(tabpc));
 			pc = tabpc + (DWORD(tabpc+4)+1) * 8;
+			if(pc < codeInfo->codelen)
+			    SET_STARTOFBASICBLOCK(pc);
 			break;
 		case IRETURN:	case LRETURN:	case ARETURN:
 		case FRETURN:	case DRETURN:	case RETURN:
 		case ATHROW:	case RET:
 			pc = pc + INSNLEN(pc);
+			if(pc < codeInfo->codelen)
+			    SET_STARTOFBASICBLOCK(pc);
 			break;
 		case WIDE:
 			wide = true;
@@ -322,7 +332,9 @@
 
 	/* Check we've processed each block at least once */
 	for (bcurr = bhead; bcurr != NULL; bcurr = bcurr->nextBB) {
-		assert((bcurr->flags & FLAG_DONEVERIFY) != 0);
+		if ((bcurr->flags & FLAG_DONEVERIFY) == 0)
+			VDBG(printf("%s.%s%s pc %d bcurr->flags 0x%04x\n", meth->class->name->data, meth->name->data, meth->signature->data, bcurr - codeInfo->perPC, bcurr->flags));
+		// assert((bcurr->flags & FLAG_DONEVERIFY) != 0);
 	}
 }
 
@@ -367,7 +379,7 @@
 
 		if (sp < meth->localsz || sp > meth->localsz + meth->stacksz) {
 			failed = true;
-			VDBG(printf("sp out of range: %d <%d> %d\n", meth->localsz, sp, meth->localsz + meth->stacksz);)
+			VDBG(printf("sp out of range: %d <%d> %d pc %d\n", meth->localsz, sp, meth->localsz + meth->stacksz, pc);)
 			break;
 		}
 
Index: jit/machine.c
===================================================================
RCS file: /home/cvspublic/kaffe/kaffe/kaffevm/jit/machine.c,v
retrieving revision 1.8
diff -u -r1.8 machine.c
--- machine.c	1998/08/26 21:42:31	1.8
+++ machine.c	1998/10/01 14:51:23
@@ -219,6 +219,19 @@
 		assert(stackno <= maxStack+maxLocal);
 
 		npc = pc + insnLen[base[pc]];
+		if ((IS_STARTOFBASICBLOCK(pc) || IS_STARTOFEXCEPTION(pc)) && !IS_DONEVERIFY(pc)) {
+		    /* unreachable basic block, skip to next one */
+		    while (npc < len && !IS_STARTOFBASICBLOCK(npc) && !IS_STARTOFEXCEPTION(npc)) {
+			npc = npc + insnLen[base[npc]];
+		    }
+		    printf("unreachable basic block pc [%d:%d]\n", pc, npc);
+		    if (IS_STARTOFBASICBLOCK(npc)) {
+			    end_basic_block();
+			    start_basic_block();
+			    stackno = STACKPOINTER(npc);
+		    }
+		    continue;
+		}
 
 DBG(JIT,	dprintf("pc = %d, npc = %d\n", pc, npc);	)
 
